<?php
/*
 * @ https://EasyToYou.eu - IonCube v11 Decoder Online
 * @ PHP 7.2 & 7.3
 * @ Decoder version: 1.0.6
 * @ Release: 10/08/2022
 */

// Decoded file for php version 72.
namespace app\controller;

/**
 * @title 限速组
 * @desc 限速组,带宽管理
 */
class BwController
{
    public $uid = 0;
    public $user_type = 0;
    public $cloudApi;
    public $child_uid = [];
    public function __construct()
    {
        $this->ceph = new \app\logic\Ceph();
        $this->uid = request()->uid;
        $this->user_type = get_user_type(request()->application);
        $this->child_uid = \think\facade\Db::name("user")->where("uid", $this->uid)->column("id") ?? [];
    }
    public function index()
    {
        $license_info = get_license_info(false, true);
        if (isset($license_info["status"]) && $license_info["status"] == 400) {
            return restful_response($license_info);
        }
        $page = input("get.page", 1, "intval");
        $per_page = input("get.per_page", 20, "intval");
        $orderby = input("get.orderby", "id");
        $sort = input("get.sort", "desc");
        $search = input("get.search", "", "trim");
        $page = 1 < $page ? $page : 1;
        $per_page = 0 < $per_page ? $per_page : 20;
        $query_cloud = input("get.cloud");
        $query_list_type = input("get.list_type", "page");
        if (!in_array($orderby, ["id", "in_bw", "out_bw", "create_time"])) {
            $orderby = "a.id";
        } else {
            $orderby = "a." . $orderby;
        }
        if (!in_array($sort, ["asc", "desc"])) {
            $sort = "desc";
        }
        if ($this->user_type == 2) {
            $field = "a.id,a.hostid,a.in_bw,a.out_bw,b.hostname";
        } else {
            $field = "a.id,a.hostid,a.old_in_bw in_bw,a.old_out_bw out_bw,b.hostname";
        }
        $count = \think\facade\Db::name("bw")->alias("a")->leftJoin("host b", "a.hostid=b.id")->where("a.type", "cloud")->group("a.id");
        $data = \think\facade\Db::name("bw")->alias("a")->field($field)->leftJoin("host b", "a.hostid=b.id")->leftJoin("interface i", "a.interfaceid=i.id")->where("i.net_id", 0)->where("a.type", "cloud")->group("a.id");
        if ($this->user_type == 1) {
            $uid = array_merge([$this->uid], $this->child_uid);
            $count = $count->whereIn("b.uid", $uid);
            $data = $data->whereIn("b.uid", $uid);
            if (is_numeric($query_cloud) && 0 < $query_cloud) {
                $count = $count->where("a.hostid", $query_cloud);
                $data = $data->where("a.hostid", $query_cloud);
            }
        } else {
            if ($this->user_type == 3) {
                $count = $count->where("a.hostid", $this->uid);
                $data = $data->where("a.hostid", $this->uid);
            } else {
                if (is_numeric($query_cloud) && 0 < $query_cloud) {
                    $count = $count->where("a.hostid", $query_cloud);
                    $data = $data->where("a.hostid", $query_cloud);
                }
            }
        }
        if (!empty($search)) {
            $count = $count->leftJoin("ip c", "a.id=c.bwid")->whereLike("c.ip", "%" . $search . "%");
            $data = $data->leftJoin("ip c", "a.id=c.bwid")->whereLike("c.ip", "%" . $search . "%");
        }
        if ($query_list_type == "all") {
            $data = $data->select()->toArray();
        } else {
            $count = $count->count();
            $total_page = ceil($count / $per_page);
            if (0 < $total_page && $total_page < $page) {
                return \think\Response::create()->code(204);
            }
            $data = $data->limit($per_page)->page($page)->order($orderby, $sort)->select()->toArray();
        }
        if (empty($data)) {
            return \think\Response::create()->code(204);
        }
        $ip = \think\facade\Db::name("ip")->alias("i")->field("i.id,i.ip,i.bwid,ips.gateway,ips.subnet_mask,ips.id ip_segment_id,ips.ip_name")->leftJoin("ip_segment ips", "i.ip_segment_id=ips.id")->whereIn("i.bwid", array_column($data, "id"))->where("i.type", "cloud")->select()->toArray();
        $ip_arr = [];
        foreach ($ip as $k => $v) {
            $bwid = $v["bwid"];
            unset($v["bwid"]);
            $ip_arr[$bwid][] = $v;
        }
        unset($ip);
        foreach ($data as $k => $v) {
            $data[$k]["ip"] = $ip_arr[$v["id"]] ?? [];
        }
        $result["data"] = $data;
        if ($query_list_type != "all") {
            $result["meta"] = ["total" => $count, "total_page" => $total_page, "page" => $page, "per_page" => $per_page];
        }
        return json($result, 200);
    }
    public function getBwIp($id)
    {
        if (empty($id)) {
            return json(["error" => lang("id_error")], 400);
        }
        $client_show_ip_remark = (int) configuration("client_show_ip_remark");
        $has_remark = true;
        if ($this->user_type == 1) {
            $hostid = \think\facade\Db::name("bw")->where("id", $id)->value("hostid");
            if (empty($hostid)) {
                return \think\Response::create()->code(204);
            }
            $cloud_info = \think\facade\Db::name("host")->field("status,uid")->where("id", $hostid)->find();
            if ($cloud_info["uid"] != $this->uid && !in_array($cloud_info["uid"], $this->child_uid)) {
                return \think\Response::create()->code(204);
            }
            $has_remark = $client_show_ip_remark == 1;
        } else {
            if ($this->user_type == 3) {
                $hostid = \think\facade\Db::name("bw")->where("id", $id)->value("hostid");
                if (empty($hostid) || $hostid != $this->uid) {
                    return \think\Response::create()->code(204);
                }
                $has_remark = $client_show_ip_remark == 1;
            }
        }
        $page = input("get.page", 1, "intval");
        $per_page = input("get.per_page", 20, "intval");
        $page = 1 < $page ? $page : 1;
        $per_page = 0 < $per_page ? $per_page : 20;
        $query_list_type = input("get.list_type", "page");
        if ($has_remark) {
            $ip_field = "a.id,a.ip,a.server_mainip,a.remark,b.subnet_mask,b.gateway";
        } else {
            $ip_field = "a.id,a.ip,a.server_mainip,b.subnet_mask,b.gateway";
        }
        $count = \think\facade\Db::name("ip")->alias("a")->where("a.bwid", $id);
        $data = \think\facade\Db::name("ip")->alias("a")->field($ip_field)->leftJoin("ip_segment b", "a.ip_segment_id=b.id")->orderRaw("field(server_mainip, 'true','false')")->where("a.bwid", $id)->group("a.id");
        if ($query_list_type == "all") {
            $data = $data->select()->toArray();
        } else {
            $count = $count->count();
            $total_page = ceil($count / $per_page);
            if (0 < $total_page && $total_page < $page) {
                return \think\Response::create()->code(204);
            }
            $data = $data->limit($per_page)->page($page)->orderRaw("INET_ATON(a.ip) ASC")->select()->toArray();
        }
        if (empty($data)) {
            return \think\Response::create()->code(204);
        }
        $result["data"] = $data;
        if ($query_list_type != "all") {
            $result["meta"] = ["total" => $count, "total_page" => $total_page, "page" => $page, "per_page" => $per_page];
        }
        return json($result, 200);
    }
    public function modify($id)
    {
        $params = input("post.");
        $info = \think\facade\Db::name("bw")->alias("a")->field("a.id,a.in_bw,a.out_bw,a.interfaceid,b.id hostid,b.hostname,b.node,b.network_type,b.status,b.kvm,b.host_type,b.rid,b.transparent")->leftJoin("host b", "a.hostid=b.id")->where("a.id", $id)->where("a.type", "cloud")->find();
        if (empty($info)) {
            return json(["error" => lang("id")], 404);
        }
        // $validate = new \app\validate\CloudValidate();
        // $validate_result = $validate->scene("modifyBw")->check($params);
        // if (!$validate_result) {
        //     return json(["error" => $validate->getError()], 400);
        // }
        $check_status = check_cloud_action($info["hostid"], $info["status"], "modify_bw");
        if ($check_status !== true) {
            return json(["error" => $check_status], 400);
        }
        if ($info["host_type"] == "adsl") {
            return json(["error" => lang("adsl_host_cannot_modify_bw")], 400);
        }
        $task = \think\facade\Db::name("task")->whereIn("status", "0,1")->where("type", "cloud_edit")->whereLike("data", "%_bw%")->find();
        if (!empty($task)) {
            return json(["error" => lang("now_modify_bw_setting")], 400);
        }
        $interface = \think\facade\Db::name("interface")->where("kvm", $info["kvm"])->where("net_id", 0)->find();
        if ($info["interfaceid"] != $interface["id"]) {
            return json(["error" => lang("cannot_use_this_api_for_other_bw_group")], 400);
        }
        $update = [];
        if (isset($params["in_bw"]) && $params["in_bw"] != $info["in_bw"]) {
            $update["in_bw"] = $params["in_bw"];
            $update["old_in_bw"] = $update["in_bw"];
        }
        if (isset($params["out_bw"]) && $params["out_bw"] != $info["out_bw"]) {
            $update["out_bw"] = $params["out_bw"];
            $update["old_out_bw"] = $update["out_bw"];
        }
        if (empty($update)) {
            return \think\Response::create()->code(200);
        }
        if ($this->user_type != 2) {
            $ResourcePackage = new \app\logic\ResourcePackage();
            $check_package = $ResourcePackage->check(0, $info["rid"], $update);
            if ($check_package["code"] != 200) {
                return json(["error" => $check_package["msg"]], 400);
            }
        }
        $HostOverFlowModel = new \app\model\HostOverFlowModel();
        $over_flow = $HostOverFlowModel->overFlowGet($info["hostid"]);
        if ($over_flow["is_over"] == 0) {
            if ($info["host_type"] == "lightHost" || $info["transparent"] == 1) {
                \think\facade\Db::name("bw")->where("id", $id)->update($update);
                \think\facade\Db::name("trigger_history")->where("hostid", $info["hostid"])->where("rule_type", "bw")->where("recover_status", 0)->update(["recover_status" => 1]);
                $bw = \think\facade\Db::name("bw")->where("id", $id)->find();
                $post["group"] = "modify_bw";
                $post["data"]["in_bw"] = $bw["in_bw"] * 128;
                $post["data"]["out_bw"] = $bw["out_bw"] * 128;
                $post["data"]["id"] = get_kvm_id($info["kvm"]);
                $this->ceph->post($info["node"], $post);
                $this->ceph->writeKvmInfo($info["hostid"]);
            } else {
                if ($info["host_type"] == "host") {
                    $del_bw = get_bw_info_by_bwid($id);
                    \think\facade\Db::name("bw")->where("id", $id)->update($update);
                    \think\facade\Db::name("trigger_history")->where("hostid", $info["hostid"])->where("rule_type", "bw")->where("recover_status", 0)->update(["recover_status" => 1]);
                    $post["group"] = "modify_iptable";
                    $post["data"]["host_network_type"] = $info["network_type"];
                    $post["data"]["del_bw"] = $del_bw;
                    $post["data"]["add_bw"] = get_bw_info_by_bwid($id);
                    $post["data"]["id"] = get_kvm_id($info["kvm"]);
                    $this->ceph->post($info["node"], $post);
                    $this->ceph->writeKvmInfo($info["hostid"]);
                } else {
                    if ($info["host_type"] == "hyperv" && isset($update["out_bw"])) {
                        $Host = \app\logic\BaseCloud::create($info["hostid"]);
                        $res = $Host->remoteSetNetcard(["out_bw" => $update["out_bw"]]);
                        if ($res["code"] != 200) {
                            return json(["error" => lang("bw_modify_failed", ["reason" => $res["msg_err"] ?: $res["msg"]])], 400);
                        }
                        \think\facade\Db::name("bw")->where("id", $id)->update($update);
                        \think\facade\Db::name("trigger_history")->where("hostid", $info["hostid"])->where("rule_type", "bw")->where("recover_status", 0)->update(["recover_status" => 1]);
                    }
                }
            }
        } else {
            \think\facade\Db::name("bw")->where("id", $id)->update($update);
        }
        $des = ["in_bw" => lang("in_bw"), "out_bw" => lang("out_bw")];
        $description = lang("log_modify_bw_success", ["hostname" => "{" . $info["hostname"] . "}", "detail" => create_edit_log($info, $update, $des)]);
        actionLog(20, $info["hostid"], $description);
        return \think\Response::create()->code(200);
    }
}

?>